
<template>
  <q-page class="flex">
    <div class="doc-container minheight-rows with-bg home">
      <div v-if="endpoints.length != 0 " class="row title-row items-center margin-bottom-20">
          <i class="fas fa-globe"></i>
          <div class="page-title">{{ $t('Applications') }}</div>
      </div>
      <div class="row md-gutter margin-bottom-20">
          <div v-for="e in endpoints"
               :key="e.name">
            <ApplicationCard
                    :application="e"
                    @click="endpointClicked(e.url)"
            />
          </div>
      </div>
      <div v-if="categories.length != 0 " class="row title-row items-center margin-bottom-20">
          <i class="fas fa-globe"></i>
          <div class="page-title">{{ $t('Categories') }}</div>
      </div>
      <div class="row md-gutter margin-bottom-20">
            <div v-for="(c, index) in categories"
               :key="c.detailUrl"
          >
            <CategoryCard :category="c"
                          :pictureSuffix="pictureSuffix"
                          @click="showCategory(index)"
            />
          </div>
      </div>
      <div v-if=" visiblePlaylists.length != 0" class="row title-row items-center margin-bottom-20">
        <i class="fas fa-globe"></i>
        <div class="page-title">{{ $t('Playlists') }}</div>
      </div>
      <div class="row md-gutter">
          <div class="row md-gutter margin-bottom-20">
            <div v-for="(p, index) in visiblePlaylists"
               :key="p.id"
            >
            <PlaylistCard
                    :playlist="p"
                    :pictureSuffix="pictureSuffix"
                    @click="showPlaylist(index)"
            />
          </div>
          </div>
      </div>
    </div>
    <div class="flex full-width footer">
      <div class="row full-width inner-footer">
        <div class="row content flex full-width">
          <div class="col flex footer-item"><a href="/aboutus">{{ $t('about.us') }}</a></div>
          <div class="col flex footer-item"><a href="../../statics/olip-help.pdf" target="_blank">{{ $t('Help') }}</a></div>
          <div class="col flex footer-item">{{ $t('FAQ') }}</div>
          <div class="col flex footer-item">{{ $t('about.disclaimer') }}</div>
          <div class="col flex footer-item"><img src="../../assets/offlineconsortium.png"></div>
        </div>
      </div>
    </div>
  </q-page>
</template>

<script>
import {mapActions, mapState} from 'vuex'
import ApplicationCard from '../../components/application_card'
import CategoryCard from '../../components/category_card'
import PlaylistCard from '../../components/playlist_card'

export default {
  name: 'Home',
  methods: {
    ...mapActions('home', [
      'listEndpoints',
      'listVisiblePlaylists'
    ]),
    ...mapActions('categories', [
      'listCategories'
    ]),
    endpointClicked: function (url) {
      window.open(url, '_blank')
    },
    showCategory: function (index) {
      this.$router.push(`/home/categories/${index}`)
    },
    showPlaylist: function (index) {
      this.$router.push(`/home/playlist/${index}`)
    }
  },
  computed: {
    ...mapState('home', {
      endpoints: (state) => state.endpoints,
      visiblePlaylists: (state) => state.visiblePlaylists
    }),
    ...mapState('categories', {
      categories: (state) => state.categories,
      pictureSuffix: (state) => state.pictureSuffix
    }),
    ...mapState('playlists', {
      playlist: (state) => state.playlists,
      pictureSuffix: (state) => state.pictureSuffix
    })
  },
  mounted: function () {
    this.listEndpoints()
    this.listCategories()
    this.listVisiblePlaylists()
  },
  components: {
    'ApplicationCard': ApplicationCard,
    'CategoryCard': CategoryCard,
    'PlaylistCard': PlaylistCard
  }

}
</script>
